# zksync
#   Copyright (C) 2017  Jonas Acres

#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.

#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.

#   You should have received a copy of the GNU General Public License along
#   with this program; if not, write to the Free Software Foundation, Inc.,
#   51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

module ZKSync
  class KeyStore
    def initialize(root_key)
      @root_key = root_key
    end

    def top_key
      @top_key ||= @root_key.child_key(".topkey")
    end

    def fs_key
      @fs_key ||= top_key.child_key(".fskey")
    end

    def file_key(archive_path)
      fs_key.child_key(".file:#{archive_path}")
    end

    def page_key(archive_path, page_num, page_hash)
      file_key(archive_path).child_key(".page:#{page_num}::#{page_hash}")
    end
  end
end
